﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace Mantis
{
    using MantisCommon;

    [ComVisible(true)]
    [ProgId("Tortoise Mantis Plugin")]
    [ Guid("abdef642-8564-471d-bdee-676f29a5593a") ]
    [ ClassInterface(ClassInterfaceType.None) ]
    public class Plugin : TortoisePlugin.Plugin
    {
        private MantisCommon.Settings.MySettingsManager settings_ = new MantisCommon.Settings.MySettingsManager();
        private MantisCommon.Settings.MySettingsControl settings_control_ = new MantisCommon.Settings.MySettingsControl();

        public Plugin()
            : base()
        {
            Updater.UpdaterHelper.CheckUpdate();

            settings_forms_.AddSettings(settings_, settings_control_);
        }

        protected override void SetParameters(string parameters)
        {
            base.SetParameters(parameters);
            settings_.Set(parameters);
        }

        public override bool ValidateParameters(IntPtr hParentWnd, string parameters)
        {
            base.ValidateParameters(hParentWnd, parameters);

            Validating frm = new Validating(parameters, settings_control_);

            return frm.ShowDialog() == System.Windows.Forms.DialogResult.OK;
        }

        // Done
        public override string GetCommitMessage2(IntPtr hParentWnd,
            string parameters,
            string commonURL,
            string commonRoot,
            string[] pathList,
            string originalMessage,
            string bugID,
            out string bugIDOut,
            out string[] revPropNames,
            out string[] revPropValues)
        {
            if (frmBS == null)
            {
                frmBS = new BugSelection(parameters);
            }

            return base.GetCommitMessage2(hParentWnd, parameters, commonURL, commonRoot, pathList, originalMessage, bugID, out bugIDOut, out revPropNames, out revPropValues);
        }
    }
}
