﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WikiCsharpCommon
{
    using Settings;

    public partial class WikiCsharpOptions : Common.Forms.formDefaultSettings
    {
        private MySettingsManager sm = new MySettingsManager();
        private MySettingsControl sc = new MySettingsControl();

        public WikiCsharpOptions(string options)
            : base()
        {
            sm.Set(options);
            AddSettings(sm, sc);
        }

        protected override void btnAccept_Click(object sender, EventArgs e)
        {
            MyBugtracker mbt = new MyBugtracker(new MySettingsManager(this.Options));
            
            Common.ProgressCallback siid = new Common.ProgressCallback(sc.updateProgress);
            mbt.RegisterProgressCallback(siid);

            if (mbt.ValidateSettings())
            {
                base.btnAccept_Click(sender, e);
            }
            else
            {
                this.DialogResult = System.Windows.Forms.DialogResult.None;
            }
        }
    }
}
